<script lang="ts">
  import ScoreChart from '@components/ScoreChart/ScoreChart.svelte';
  import ServiceStatusTable from '@components/ServiceStatusTable/ServiceStatusTable.svelte';
  import { Dropdown, DropdownItem, DropdownMenu, DropdownToggle, Input } from '@sveltestrap/sveltestrap';
  import { settings } from '@stores';
  import { page } from '$app/stores';
  import CtfProgress from '@components/CtfProgress/CtfProgress.svelte';
  import LeaderBoard from '@components/Leaderboard/LeaderBoard.svelte';
  import Fa from 'svelte-fa';
  import { faGear } from '@fortawesome/free-solid-svg-icons';

  let visibleTeams: Record<string, boolean> = {};

  function handleHideTeam(teamId: string) {
    visibleTeams[teamId] = false;
  }

  type Tab = '#infrastructure' | '#ctf' | '#leaderboard';
  const validTabs: Array<Tab> = [];

  if ($settings.flags.infrastructure) validTabs.push('#infrastructure');
  if ($settings.flags.ctf) validTabs.push('#ctf');
  if ($settings.flags.leaderboard) validTabs.push('#leaderboard');

  // todo initial page load isn't respecting the #selector
  let displayLongNames = true;
  let activeTab = validTabs[0];
  $: console.log(validTabs, activeTab, $page.url.hash, $page.url.hash in validTabs);
  $: if (validTabs.includes($page.url.hash as Tab)) activeTab = $page.url.hash as Tab;
</script>

<div class="m-4">
  {#if $settings.flags.scoreChart}
    <ScoreChart shortNames={!displayLongNames} {visibleTeams} />
  {/if}
</div>

<div class="m-4 pb-5">
  <div class="position-relative">
    <ul class="nav nav-tabs">
      {#if $settings.flags.infrastructure}
        <li class="nav-item">
          <a class:active={activeTab === '#infrastructure'} class="nav-link" href="#infrastructure">
            Infrastructure Status
          </a>
        </li>
      {/if}
      {#if $settings.flags.ctf}
        <li class="nav-item">
          <a class:active={activeTab === '#ctf'} class="nav-link active" href="#ctf"> CTF Flags </a>
        </li>
      {/if}
      {#if $settings.flags.leaderboard}
        <li class="nav-item">
          <a class:active={activeTab === '#leaderboard'} class="nav-link" href="#leaderboard"> Leaderboard </a>
        </li>
      {/if}
    </ul>
    <div class="position-absolute top-0 end-0 clickable">
      <Dropdown autoClose="outside">
        <DropdownToggle tag="div">
          <Fa size="2x" icon={faGear} />
        </DropdownToggle>
        <DropdownMenu>
          <DropdownItem
            on:click={(e) => {
              e.preventDefault();
              displayLongNames = !displayLongNames;
            }}
          >
            <Input
              class="d-inline-block clickable"
              type="switch"
              label="Display Long Names"
              bind:checked={displayLongNames}
            />
          </DropdownItem>
          <DropdownItem on:click={() => (visibleTeams = {})}>Reset Hidden Teams</DropdownItem>
        </DropdownMenu>
      </Dropdown>
    </div>
  </div>

  <div class="pb-5">
    <!-- hidden components still render and execute in the background, -->
    <!-- so we want to prevent them from rendering if the relevant flag is not present -->
    {#if $settings.flags.infrastructure}
      <div hidden={activeTab !== '#infrastructure'}>
        <ServiceStatusTable shortNames={!displayLongNames} onHideTeam={handleHideTeam} {visibleTeams} />
      </div>
    {/if}
    {#if $settings.flags.ctf}
      <div hidden={activeTab !== '#ctf'}>
        <CtfProgress shortNames={!displayLongNames} {visibleTeams} onHideTeam={handleHideTeam} />
      </div>
    {/if}
    {#if $settings.flags.leaderboard}
      <div hidden={activeTab !== '#leaderboard'}>
        <LeaderBoard
          shortNames={!displayLongNames}
          showCtf={$settings.flags.ctf}
          showService={$settings.flags.infrastructure}
        />
      </div>
    {/if}
  </div>
</div>
